Installer - Bug #19986

puppetserver fails to restart after installation
06/13/2017 02:27 AM - Evgeni Golov
Description
Ohai,

after installing a fresh 1.15 (using forklift) everything is working fine:

[root@centos7-foreman-1-15 ~]# systemctl status puppetserver.service
® puppetserver.service - puppetserver Service

Loaded: loaded (/usr/lib/systemd/system/puppetserver.service; enabled; vendor preset: disabled)

Active: active (running) since Tue 2017-06-13 06:13:28 UTC; 1min 19s ago
Main PID: 4996 (java)

CGroup: /system.slice/puppetserver.service

L-4996 /usr/bin/java -Xms2G -Xmx2G -XX:MaxPermSize=256m -Djava.security.egd=/dev/urando

m —-XX:0nOutOfMemoryError=kill -9 %p -cp /opt/puppetlabs/server/apps/puppetserver/puppet-server-rel
ease.jar clojure.main -m puppetlabs.trapperkeeper.main —--config /etc/puppetlabs/puppetserver/conf.
d —-bootstrap-config /...

Jun 13 06:12:54 centos7-foreman-1-15.example.com systemd[l]: Starting puppetserver Service...

Jun 13 06:12:54 centos7-foreman-1-15.example.com puppetserver[4987]: OpendDK 64-Bit Server VM warn
ing: ignoring option MaxPermSize=256m; support was removed in 8.0

Jun 13 06:13:28 centos7-foreman-1-15.example.com systemd[l]: Started puppetserver Service.

However, when | try to restart the puppetserver, it errors out:

[root@centos7-foreman-1-15 ~]# systemctl restart puppetserver
Job for puppetserver.service failed because the control process exited with error code. See "syste
mctl status puppetserver.service" and "journalctl -xe" for details.

[root@centos7—-foreman—-1-15 ~]# journalctl -xe

—— Unit puppetserver.service has begun starting up.

Jun 13 06:15:28 centos7-foreman-1-15.example.com puppetserver[5697]: OpendDK 64-Bit Server VM warn
ing: ignoring option MaxPermSize=256m; support was removed in 8.0

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: Exception in thread "main" ja
va.io.FileNotFoundException: /etc/puppetlabs/puppet/ssl/crl.pem (Permission denied)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.io.FileOutputStream.o
pen0 (Native Method)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.io.FileOutputStream.o
pen (FileOutputStream. java:270)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.io.FileOutputStream.<
init> (FileOutputStream. java:213)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.io.FileOutputStream.<
init> (FileOutputStream. java:162)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.java.io$fn__9570.1
nvokeStatic (io.clj:355)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.java.io$fn__ 9570.1
nvoke (io.clj:354)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.lang.MultiFn.invok
e (MultiFn. java:238)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.java.io$copy.invok
eStatic(io.clj:406)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.java.ioScopy.doInv
oke (io.clj:391)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.lang.RestFn.invoke
(RestFn. java:425)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at me.raynes.fsS$copy.invokeSt
atic(fs.clj:293)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at me.raynes.fs$copy.invoke (f
s.clj:289)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.puppetserver.ce
rtificate_authorityS$Sevall6660Sretrieve_ca_crl_BANG__ 16665$fn__ 16666.invoke (certificate_authority.
clj:752)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.puppetserver.ce
rtificate_authority$evall6660Sretrieve_ca_crl_BANG___ 16665.invoke (certificate_authority.clj:744)
Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.services.ca.cer
tificate_authority_serviceS$reify_ 24897S$service_fnk__ 5222 _auto__ _positional$reify_ 24908.retrieve
_ca_crl_BANG_ (certificate_authority_service.clj:52)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.services.protoc
ols.ca$eval24835Sfn_ 24836$G__24825__24839.invoke(ca.clj:3)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.services.protoc
ols.ca$eval24835$fn__ 248365$G__24824___ 24843 .invoke(ca.clj:3)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core$partial$fn__ 4
759.invoke (core.clj:2515)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.services.master

.master_serviceS$reify_ 33186S$service_fnk__ 5222 _auto__ positional$reify_ 33207.init (master_service
.clj:52)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.s
ervicesS$Seval5024$fn__ 5025$G__5012__5028.invoke (services.clj:8)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.s
ervices$eval5024$fn_ 5025$G__5011_ 5032.invoke (services.clj:8)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$evall3792$run_lifecycle_fn_BANG___ 13799$fn__13800.invoke (internal.clj:204)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalSevall3792$run_lifecycle_fn_BANG__ 13799.invoke (internal.clj:187)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$evall3821$run_lifecycle_fns_ 13826$fn__13827.invoke (internal.clj:238)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$Sevall3821$run_lifecycle_fns__13826.invoke (internal.clj:215)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$evall4291$build_app_STAR___ 14300$fnSreify_ 14310.init (internal.clj:588)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalSevall4337$boot_services_for_app_ STAR__STAR__ 14344S$fn_ 14345$fn_ _14347.invoke (internal.clj
:616)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$Sevall4337$boot_services_for_app_STAR__STAR__ 14344S$fn_ 14345.invoke (internal.clj:615)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$evall4337$boot_services_for_app_STAR__STAR___ 14344 .invoke (internal.clj:609)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core$partial$fn__ 4
761.invoke (core.clj:2521)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$Sevall3860$initialize_lifecycle_worker_ 13871$fn_ 13872$fn__ 13958S$state_machine_ 11832__ aut
o__ 13959$%$fn_ _13961l.invoke (internal.clj:255)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at puppetlabs.trapperkeeper.i
nternalS$evall3860$initialize_lifecycle_worker_ 13871$fn__ 13872$fn_ 13958$state_machine_ 11832__ aut

o___13959.invoke (internal.clj:255)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async.impl.io
c_macros$run_state_machine.invokeStatic (ioc_macros.clj:1012)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async.impl.io

c_macros$run_state_machine.invoke (ioc_macros.clj:1011)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async.impl.io
c_macros$run_state_machine_wrapped.invokeStatic (ioc_macros.clj:1016)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async.impl.io
c_macros$run_state_machine_wrapped.invoke (ioc_macros.clj:1014)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async$ioc_alt
S_BANG_S$fn__12000.invoke (async.clj:383)
Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async$do_alts
$fn_ 11946$fn__11949.invoke (async.clj:252)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.core.async.impl.ch
annels.ManyToManyChannel$fn_ 6756$fn__6757.invoke (channels.clj:95)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at clojure.lang.AFn.run (AFn.j
ava:22)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.util.concurrent.Threa
dPoolExecutor.runWorker (ThreadPoolExecutor. java:1142)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.util.concurrent.Threa
dPoolExecutor$Worker.run (ThreadPoolExecutor. java:617)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: at java.lang.Thread.run (Threa
d.java:748)

Jun 13 06:15:57 centos7-foreman-1-15.example.com puppetserver[5697]: Background process 5704 exite

d before start had completed

Jun 13 06:15:57 centos7-foreman-1-15.example.com systemd[l]: puppetserver.service: control process
exited, code=exited status=1

Jun 13 06:15:57 centos7-foreman-1-15.example.com systemd[l]: Failed to start puppetserver Service.
—— Subject: Unit puppetserver.service has failed

The exception is slightly misleading, as the file is readable by Puppet just fine:

[root@centos7—foreman-1-15 ~]# 1ls —alh /etc/puppetlabs/puppet/ssl/
total 4.0K

drwxrwx—--x. 8 root puppet 126 Jun 13 06:12
drwxr-xr-x. 3 root root 127 Jun 13 06:12 ..
drwxr-xr-x. 5 puppet puppet 158 Jun 13 06:12 ca
drwxr-xr-x. 2 root puppet 6 Jun 13 06:12 certificate_requests
drwxr-xr-x. 2 root puppet 64 Jun 13 06:12 certs
-rw-r—--r—-—. 1 root puppet 987 Jun 13 06:13 crl.pem
drwxr-x—-—-—. 2 root puppet 6 Jun 13 06:05 private
drwxr-x—-——. 2 root puppet 50 Jun 13 06:12 private_keys
2

drwxr-xr-x. root puppet 50 Jun 13 06:12 public_keys

But what it actually wants, is being able to write that file, and thus changing the owner to "puppet” fixes the issue:

[root@centos7-foreman—-1-15 ~]# chown puppet /etc/puppetlabs/puppet/ssl/crl.pem
[root@centos7-foreman-1-15 ~]# systemctl restart puppetserver
[root@centos7-foreman—-1-15 ~]# systemctl status puppetserver.service
® puppetserver.service - puppetserver Service
Loaded: loaded (/usr/lib/systemd/system/puppetserver.service; enabled; vendor preset: disabled)
Active: active (running) since Tue 2017-06-13 06:22:01 UTC; 50s ago
Process: 5679 ExecStop=/opt/puppetlabs/server/apps/puppetserver/bin/puppetserver stop (code=exit
ed, status=0/SUCCESS)
Process: 7760 ExecStart=/opt/puppetlabs/server/apps/puppetserver/bin/puppetserver start (code=ex
ited, status=0/SUCCESS)
Main PID: 7767 (java)
CGroup: /system.slice/puppetserver.service
L7767 /usr/bin/java -Xms2G -Xmx2G -XX:MaxPermSize=256m -Djava.security.egd=/dev/urando
m —-XX:0nOutOfMemoryError=kill -9 %p -cp /opt/puppetlabs/server/apps/puppetserver/puppet-server-rel
ease.jar clojure.main -m puppetlabs.trapperkeeper.main —-config /etc/puppetlabs/puppetserver/conf.
d —-bootstrap-config /...

Jun 13 06:21:35 centos7-foreman-1-15.example.com systemd[1l]: Starting puppetserver Service...

Jun 13 06:21:35 centos7-foreman-1-15.example.com puppetserver[7760]: OpendDK 64-Bit Server VM warn
ing: ignoring option MaxPermSize=256m; support was removed in 8.0

Jun 13 06:22:01 centos7-foreman-1-15.example.com systemd[1l]: Started puppetserver Service.

Note, setting the perms to 664 does not help, as Puppet itself tries to enforce the 644 perms.

History

#1 - 06/14/2017 05:42 AM - Evgeni Golov

The correct permissions seem to be
$ sudo 1ls —-lah /etc/puppetlabs/puppet/ssl/
total 4.0K

drwxrwx—--x. 8 puppet puppet 126 Jun 14 08:45
drwxr-xr-x. 3 root root 127 Jun 14 08:45 ..
drwxr-xr-x. 5 puppet puppet 158 Jun 14 08:45 ca
drwxr-xr-x. 2 puppet puppet 6 Jun 14 08:45 certificate_requests
drwxr-xr-x. 2 puppet puppet 72 Jun 14 08:45 certs
—-rw-r—--r——. 1 puppet puppet 999 Jun 14 08:46 crl.pem
drwxr-x—-—-—. 2 puppet puppet 6 Jun 14 08:36 private
drwxr-x——-—. 2 puppet puppet 58 Jun 14 08:45 private_keys
2

drwxr—-xr-x. puppet puppet 58 Jun 14 08:45 public_keys

Wonder what changes them, though.

#2 - 06/14/2017 05:54 AM - Evgeni Golov

# grep "etc/puppetlabs/puppet/.*root" /var/log/foreman-installer/katello.log

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'certdir': 'File[/etc/puppetlabs/puppet
/ssl/certs] {:path=>"/etc/puppetlabs/puppet/ssl/certs", :mode=>"755", :owner=>"root", :ensure=>:directory, :log
level=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'ssldir': 'File[/etc/puppetlabs/puppet/
ssl]{:path=>"/etc/puppetlabs/puppet/ssl", :mode=>"771", :owner=>"root", :ensure=>:directory, :loglevel=>:debug
, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'publickeydir': 'File[/etc/puppetlabs/p
uppet/ssl/public_keys] {:path=>"/etc/puppetlabs/puppet/ssl/public_keys", :mode=>"755", :owner=>"root", :ensure=
>:directory, :loglevel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'requestdir': 'File[/etc/puppetlabs/pup
pet/ssl/certificate_requests] {:path=>"/etc/puppetlabs/puppet/ssl/certificate_requests", :mode=>"755", :owner=>
"root", :ensure=>:directory, :loglevel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'privatekeydir': 'File[/etc/puppetlabs/
puppet/ssl/private_keys]{:path=>"/etc/puppetlabs/puppet/ssl/private_keys", :mode=>"750", :owner=>"root", :ensu
re=>:directory, :loglevel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'privatedir': 'File[/etc/puppetlabs/pup
pet/ssl/private] {:path=>"/etc/puppetlabs/puppet/ssl/private", :mode=>"750", :owner=>"root", :ensure=>:director
y, :loglevel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'hostcert': 'File[/etc/puppetlabs/puppe
t/ssl/certs/centos7-bats-ci.example.com.pem] { :path=>"/etc/puppetlabs/puppet/ssl/certs/centos7-bats-ci.example.
com.pem", :mode=>"644", :owner=>"root", :ensure=>:file, :loglevel=>:debug, :links=>:follow, :backup=>false}'
[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'hostprivkey': 'File[/etc/puppetlabs/pu
ppet/ssl/private_keys/centos7-bats-ci.example.com.pem] { :path=>"/etc/puppetlabs/puppet/ssl/private_keys/centos?7
-bats-ci.example.com.pem", :mode=>"640", :owner=>"root", :ensure=>:file, :loglevel=>:debug, :links=>:follow,
backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'hostpubkey': 'File[/etc/puppetlabs/pup
pet/ssl/public_keys/centos7-bats-ci.example.com.pem] {:path=>"/etc/puppetlabs/puppet/ssl/public_keys/centos7-ba
ts—ci.example.com.pem", :mode=>"644", :owner=>"root", :ensure=>:file, :loglevel=>:debug, :links=>:follow, :bac
kup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'localcacert': 'File[/etc/puppetlabs/pu
ppet/ssl/certs/ca.pem] { :path=>"/etc/puppetlabs/puppet/ssl/certs/ca.pem", :mode=>"644", :owner=>"root", :ensure
=>:file, :loglevel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] Using settings: adding file resource 'hostcrl': 'File[/etc/puppetlabs/puppet
/ssl/crl.pem] {:path=>"/etc/puppetlabs/puppet/ssl/crl.pem", :mode=>"644", :owner=>"root", :ensure=>:file, :logl
evel=>:debug, :links=>:follow, :backup=>false}'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl]/owner: owner changed 'puppet' to 'root'
[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/certs]/owner: owner changed 'puppet' to 'ro
ot'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/public_keys]/owner: owner changed 'puppet'
to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/certificate_requests]/owner: owner changed
'puppet' to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/private_keys]/owner: owner changed 'puppet'
to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/private]/owner: owner changed 'puppet' to '
root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/certs/centos7-bats—-ci.example.com.pem]/owne
r: owner changed 'puppet' to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/private_keys/centos7-bats-ci.example.com.pe

m] /owner: owner changed 'puppet' to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/public_keys/centos7-bats—ci.example.com.pem
] /owner: owner changed 'puppet' to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/certs/ca.pem]/owner: owner changed 'puppet'
to 'root'

[DEBUG 2017-06-14 09:46:50 main] /File[/etc/puppetlabs/puppet/ssl/crl.pem]/owner: owner changed 'puppet' to '
root'
#3 - 08/09/2017 02:40 AM - Evgeni Golov
- Bugzilla link set to 1470119

#4 - 08/10/2017 12:01 PM - Eric Helms

I noticed that if you re-run it, it puts the permissions back to puppet/puppet and everything works fine. It appears to do this on initial runs only.

#5 - 08/11/2017 01:34 PM - Eric Helms

A little more context to #2, that output happens after this output indicating its after the catalog run from the puppet apply:
[DEBUG 2017-08-11 12:23:18 main] Evicting cache entry for environment 'production'
[DEBUG 2017-08-11 12:23:18 main] Caching environment 'production' (ttl = 0 sec)

[DEBUG 2017-08-11 12:23:19 main] Finishing transaction 39447760

[DEBUG 2017-08-11 12:23:19 main] Storing state

[DEBUG 2017-08-11 12:23:19 main] Stored state in 0.18 seconds

[ WARN 2017-08-11 12:23:19 main] Applied catalog in 254.14 seconds
[DEBUG 2017-08-11 12:23:19 main] Applying settings catalog for sections main, reporting, metrics

#6 - 08/11/2017 07:59 PM - Ewoud Kohl van Wijngaarden

It's also good to know that | can reproduce this on a plain Foreman + Puppet server.

On the first run:

[DEBUG 2017-08-11 23:28:38 main] Using settings: adding file resource 'hostcrl': 'File[/etc/puppetlabs/puppet
/ssl/crl.pem] {:path=>"/etc/puppetlabs/puppet/ssl/crl.pem", :mode=>"644", :owner=>"root", :ensure=>:file, :logl
evel=>:debug, :links=>:follow, :backup=>false}'

On the second run:

[DEBUG 2017-08-11 23:56:31 main] Using settings: adding file resource 'hostcrl': 'File[/etc/puppetlabs/puppet
/ssl/crl.pem] {:path=>"/etc/puppetlabs/puppet/ssl/crl.pem", :mode=>"644", :owner=>"puppet", :group=>"puppet",

ensure=>:file, :loglevel=>:debug, :links=>:follow, :backup=>false}'

That leads me to think that puppet automatically manages files that are used for configuration. While initializing the first run the puppet user does not
exist, that only happens after the puppetserver package is installed. | think explicitly managing this file resource is the way to go.

#7 - 10/04/2017 12:09 PM - Ewoud Kohl van Wijngaarden

- Project changed from Foreman to Installer

#8 - 10/05/2017 06:58 AM - Ewoud Kohl van Wijngaarden

- Status changed from New to Resolved

It appears it was fixed in puppetserver 2.8.0 with the automatic CRL refresher. See
https://projects.theforeman.org/issues/2
https://docs.puppet.com/puppetserver/2.8/release_notes.html#new-feature-automatic-crl-refresh-on-certificate-revocation
http://www.tcpdf.org

